## openldap 2.4.57+dfsg

=== contrib/slapd-modules/comp_match/Makefile ===
# $OpenLDAP$
# This work is part of OpenLDAP Software <http://www.openldap.org/>.
#
# Copyright 2003-2021 The OpenLDAP Foundation.
# Portions Copyright 2004 by IBM Corporation.
# All rights reserved.

# Copyright 2004 Sang Seok Lim, IBM Corp. All Rights Reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted only as authorized by the OpenLDAP
# Public License.
#
# A copy of this license is available in the file LICENSE in the
# top-level directory of the distribution or, alternatively, at
# <http://www.OpenLDAP.org/license.html>.

LDAP_SRC = ../../..
LDAP_BUILD = $(LDAP_SRC)
LDAP_INC = -I$(LDAP_BUILD)/include -I$(LDAP_SRC)/include -I$(LDAP_SRC)/servers/slapd
LDAP_LIB = $(LDAP_BUILD)/libraries/libldap_r/libldap_r.la \
	$(LDAP_BUILD)/libraries/liblber/liblber.la

SNACC_DIR = ../$(LDAP_SRC)/snacc
SNACC_INC = -I$(SNACC_DIR) -I$(SNACC_DIR)/c-lib/inc
SNACC_LIB = $(SNACC_DIR)/c-lib/libcasn1.a

SSL_DIR = /usr/local
SSL_INC = -I$(SSL_DIR)/include/openssl
SSL_LIB = -lcrypto -L$(SSL_DIR)/lib

LIBTOOL = $(LDAP_BUILD)/libtool
CC = gcc
OPT = -g -O2 -Wall
DEFS = -DLDAP_COMPONENT
INCS = $(LDAP_INC) $(SNACC_INC) $(SSL_INC)
LIBS = $(LDAP_LIB) $(SNACC_LIB) $(SSL_LIB)

PROGRAMS = compmatch.la
LTVER = 0:0:0

prefix=/usr/local
exec_prefix=$(prefix)
ldap_subdir=/openldap

libdir=$(exec_prefix)/lib
libexecdir=$(exec_prefix)/libexec
moduledir = $(libexecdir)$(ldap_subdir)

.SUFFIXES: .c .o .lo

.c.lo:
	$(LIBTOOL) --mode=compile $(CC) $(OPT) $(DEFS) $(INCS) -c $<

all: $(PROGRAMS)

compmatch.la: componentlib.lo init.lo certificate.lo asn_to_syn_mr.lo authorityKeyIdentifier.lo crl.lo
	$(LIBTOOL) --mode=link $(CC) $(OPT) -version-info $(LTVER) \
	-rpath $(moduledir) -module -o $@ $? $(LIBS)

clean:
	rm -rf *.o *.lo *.la .libs

install: $(PROGRAMS)
	mkdir -p $(DESTDIR)$(moduledir)
	for p in $(PROGRAMS) ; do \
		$(LIBTOOL) --mode=install cp $$p $(DESTDIR)$(moduledir) ; \
	done

=== contrib/slapd-modules/noopsrch/Makefile ===
# $OpenLDAP$
# This work is part of OpenLDAP Software <http://www.openldap.org/>.
#
# Copyright 1998-2021 The OpenLDAP Foundation.
# Copyright 2004 Howard Chu, Symas Corp. All Rights Reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted only as authorized by the OpenLDAP
# Public License.
#
# A copy of this license is available in the file LICENSE in the
# top-level directory of the distribution or, alternatively, at
# <http://www.OpenLDAP.org/license.html>.

LDAP_SRC = ../../..
LDAP_BUILD = $(LDAP_SRC)
LDAP_INC = -I$(LDAP_BUILD)/include -I$(LDAP_SRC)/include -I$(LDAP_SRC)/servers/slapd
LDAP_LIB = $(LDAP_BUILD)/libraries/libldap_r/libldap_r.la \
	$(LDAP_BUILD)/libraries/liblber/liblber.la

LIBTOOL = $(LDAP_BUILD)/libtool
CC = gcc
OPT = -g -O2 -Wall
DEFS = -DSLAPD_OVER_NOOPSRCH=SLAPD_MOD_DYNAMIC
INCS = $(LDAP_INC)
LIBS = $(LDAP_LIB)

PROGRAMS = noopsrch.la
LTVER = 0:0:0

prefix=/usr/local
exec_prefix=$(prefix)
ldap_subdir=/openldap

libdir=$(exec_prefix)/lib
libexecdir=$(exec_prefix)/libexec
moduledir = $(libexecdir)$(ldap_subdir)

.SUFFIXES: .c .o .lo

.c.lo:
	$(LIBTOOL) --mode=compile $(CC) $(OPT) $(DEFS) $(INCS) -c $<

all: $(PROGRAMS)

noopsrch.la: noopsrch.lo
	$(LIBTOOL) --mode=link $(CC) $(OPT) -version-info $(LTVER) \
	-rpath $(moduledir) -module -o $@ $? $(LIBS)

clean:
	rm -rf *.o *.lo *.la .libs

install: $(PROGRAMS)
	mkdir -p $(DESTDIR)$(moduledir)
	for p in $(PROGRAMS) ; do \
		$(LIBTOOL) --mode=install cp $$p $(DESTDIR)$(moduledir) ; \
	done

=== doc/guide/admin/Makefile ===
## Makefile for OpenLDAP Administrator's Guide
# $OpenLDAP$
## This work is part of OpenLDAP Software <http://www.openldap.org/>.
##
## Copyright 2005-2021 The OpenLDAP Foundation.
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted only as authorized by the OpenLDAP
## Public License.
##
## A copy of this license is available in the file LICENSE in the
## top-level directory of the distribution or, alternatively, at
## <http://www.OpenLDAP.org/license.html>.
all: guide.html index.html

# for website building (for webmaster use, don't change)
www: guide.html index.html OpenLDAP-Admin-Guide.pdf

sdf-src: \
	../plain.sdf \
	../preamble.sdf \
	abstract.sdf \
	access-control.sdf \
	appendix-changes.sdf \
	appendix-common-errors.sdf \
	appendix-configs.sdf \
	appendix-contrib.sdf \
	appendix-deployments.sdf \
	appendix-ldap-result-codes.sdf \
	appendix-recommended-versions.sdf \
	appendix-upgrading.sdf \
	backends.sdf \
	config.sdf \
	dbtools.sdf \
	glossary.sdf \
	guide.sdf \
	install.sdf \
	intro.sdf \
	maintenance.sdf \
	master.sdf \
	monitoringslapd.sdf \
	overlays.sdf \
	preface.sdf \
	quickstart.sdf \
	referrals.sdf \
	replication.sdf \
	runningslapd.sdf \
	sasl.sdf \
	schema.sdf \
	security.sdf \
	slapdconfig.sdf \
	title.sdf \
	tls.sdf \
	troubleshooting.sdf \
	tuning.sdf

sdf-img: \
	../images/LDAPlogo.gif \
	allmail-en.png \
	allusersgroup-en.png \
	config_dit.png \
	config_local.png \
	config_ref.png \
	config_repl.png \
	delta-syncrepl.png \
	dual_dc.png \
	intro_dctree.png \
	intro_tree.png \
	ldap-sync-refreshandpersist.png \
	ldap-sync-refreshonly.png \
	n-way-multi-provider.png \
	push-based-complete.png \
	push-based-standalone.png \
	refint.png \
	set-following-references.png \
	set-memberUid.png \
	set-recursivegroup.png 

guide.html: guide.sdf sdf-src sdf-img
	sdf -2html guide.sdf

index.html: index.sdf sdf-src sdf-img
	sdf -2topics index.sdf

admin.html: admin.sdf sdf-src sdf-img
	sdf -DPDF -2html admin.sdf

guide.pdf: admin.html guide.book
	htmldoc --batch guide.book -f guide.pdf

OpenLDAP-Admin-Guide.pdf: admin.html guide.book
	htmldoc --batch guide.book -f OpenLDAP-Admin-Guide.pdf

clean: 
	rm -f *.pdf *.html *~ *.bak

=== debian/changelog ===
openldap (2.4.57+dfsg-3) unstable; urgency=medium

  * Link smbk5pwd with -lkrb5. (Closes: #988565)

 -- Ryan Tandy <ryan@nardis.ca>  Sat, 15 May 2021 16:03:34 -0700

openldap (2.4.57+dfsg-2) unstable; urgency=medium

  * Fix slapd assertion failure in Certificate List Exact Assertion validation
    (ITS#9454) (CVE-2021-27212)

 -- Ryan Tandy <ryan@nardis.ca>  Sun, 14 Feb 2021 09:26:41 -0800

openldap (2.4.57+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Fixed slapd crashes in Certificate Exact Assertion processing
      (ITS#9404, ITS#9424) (CVE-2020-36221)
    - Fixed slapd assertion failures in saslAuthzTo validation
      (ITS#9406, ITS#9407) (CVE-2020-36222)
    - Fixed slapd crash in Values Return Filter control handling
      (ITS#9408) (CVE-2020-36223)
    - Fixed slapd crashes in saslAuthzTo processing
      (ITS#9409, ITS#9412, ITS#9413)
      (CVE-2020-36224, CVE-2020-36225, CVE-2020-36226)
    - Fixed slapd assertion failure in X.509 DN parsing
      (ITS#9423) (CVE-2020-36230)
    - Fixed slapd crash in X.509 DN parsing (ITS#9425) (CVE-2020-36229)
    - Fixed slapd crash in Certificate List Exact Assertion processing
      (ITS#9427) (CVE-2020-36228)
    - Fixed slapd infinite loop with Cancel operation
      (ITS#9428) (CVE-2020-36227)

 -- Ryan Tandy <ryan@nardis.ca>  Sat, 23 Jan 2021 08:57:07 -0800

=== debian/control ===
Source: openldap
Section: net
Priority: optional
Maintainer: Debian OpenLDAP Maintainers <pkg-openldap-devel@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>,
 Torsten Landschoff <torsten@debian.org>,
 Ryan Tandy <ryan@nardis.ca>
Build-Depends: debhelper (>= 10),
               dpkg-dev (>= 1.17.14),
               groff-base,
               heimdal-multidev (>= 7.4.0.dfsg.1-1~) <!pkg.openldap.noslapd>,
               libargon2-dev <!pkg.openldap.noslapd>,
               libdb5.3-dev <!pkg.openldap.noslapd>,
               libgnutls28-dev,
               libltdl-dev <!pkg.openldap.noslapd>,
               libperl-dev (>= 5.8.0) <!pkg.openldap.noslapd>,
               libsasl2-dev,
               libwrap0-dev <!pkg.openldap.noslapd>,
               nettle-dev <!pkg.openldap.noslapd>,
               perl:any,
               po-debconf,
               unixodbc-dev <!pkg.openldap.noslapd>
Build-Conflicts: libbind-dev, bind-dev, autoconf2.13
Standards-Version: 4.5.0
Homepage: https://www.openldap.org/
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/openldap-team/openldap.git
Vcs-Browser: https://salsa.debian.org/openldap-team/openldap

Package: slapd
Architecture: any
Build-Profiles: <!pkg.openldap.noslapd>
Pre-Depends: debconf (>= 0.5) | debconf-2.0, ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, libldap-2.4-2 (= ${binary:Version}),
 coreutils (>= 4.5.1-1), psmisc, perl:any (>> 5.8.0) | libmime-base64-perl,
 adduser, lsb-base (>= 3.2-13), ${perl:Depends}, ${misc:Depends}
Recommends: ldap-utils
Suggests: libsasl2-modules,
 libsasl2-modules-gssapi-mit | libsasl2-modules-gssapi-heimdal
Conflicts: umich-ldapd, ldap-server, libltdl3 (= 1.5.4-1)
Replaces: libldap2, ldap-utils (<< 2.2.23-3)
Provides: ldap-server, ${slapd:Provides}
Description: OpenLDAP server (slapd)
 This is the OpenLDAP (Lightweight Directory Access Protocol) server
 (slapd). The server can be used to provide a standalone directory
 service.

Package: slapd-contrib
Architecture: any
Build-Profiles: <!pkg.openldap.noslapd>
Depends: slapd (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: slapd-smbk5pwd
Breaks: slapd-smbk5pwd (<< 2.4.47+dfsg-2~)
Replaces: slapd-smbk5pwd (<< 2.4.47+dfsg-2~)
Description: contributed plugins for OpenLDAP slapd
 This package contains a number of slapd overlays and plugins contributed by
 the OpenLDAP community. While distributed as part of OpenLDAP Software, they
 are not necessarily supported by the OpenLDAP Project.

Package: slapd-smbk5pwd
Architecture: all
Section: oldlibs
Build-Profiles: <!pkg.openldap.noslapd>
Depends: slapd-contrib, ${misc:Depends}
Breaks: slapd (<< 2.4.47+dfsg-2~)
Description: transitional package for slapd-contrib
 This is a transitional package from slapd-smbk5pwd to slapd-contrib. It can be
 safely removed.

Package: ldap-utils
Architecture: any
Depends: ${shlibs:Depends}, libldap-2.4-2 (= ${binary:Version}), ${misc:Depends}
Suggests: libsasl2-modules,
 libsasl2-modules-gssapi-mit | libsasl2-modules-gssapi-heimdal
Conflicts: umich-ldap-utils, openldap-utils, ldap-client
Replaces: openldap-utils, slapd (<< 2.2.23-0.pre6), openldapd
Provides: ldap-client, openldap-utils
Description: OpenLDAP utilities
 This package provides utilities from the OpenLDAP (Lightweight
 Directory Access Protocol) package. These utilities can access a
 local or remote LDAP server and contain all the client programs
 required to access LDAP servers.

Package: libldap-2.4-2
Section: libs
Architecture: any
Multi-Arch: same
Conflicts: ldap-utils (<= 2.1.23-1)
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libldap-common
Replaces: libldap2, libldap-2.3-0
Description: OpenLDAP libraries
 These are the run-time libraries for the OpenLDAP (Lightweight Directory
 Access Protocol) servers and clients.

Package: libldap-common
Section: libs
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Replaces: libldap-2.4-2 (<< 2.4.44+dfsg-1)
Description: OpenLDAP common files for libraries
 These are common files for the run-time libraries for the OpenLDAP
 (Lightweight Directory Access Protocol) servers and clients.

Package: libldap2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Conflicts: libldap-dev, libopenldap-dev
Replaces: libopenldap-dev
Provides: libldap-dev
Depends: libldap-2.4-2 (= ${binary:Version}), ${misc:Depends}
Description: OpenLDAP development libraries
 This package allows development of LDAP applications using the OpenLDAP
 libraries. It includes headers, libraries and links to allow static and
 dynamic linking.

Package: slapi-dev
Section: libdevel
Architecture: any
Build-Profiles: <!pkg.openldap.noslapd>
Depends: slapd (= ${binary:Version}), ${misc:Depends}
Description: development libraries for OpenLDAP SLAPI plugin interface
 This package allows development of plugins for the OpenLDAP slapd server
 using the SLAPI interface.  It includes the headers and libraries needed
 to build such plugins.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# Set this variable if you're building packages outside of Debian and don't
# want the checks for DFSG-freeness.
#DFSG_NONFREE = 1

export DEB_CFLAGS_MAINT_APPEND := -Wall -Wno-format-extra-args -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
export DEB_BUILD_MAINT_OPTIONS := hardening=+pie,+bindnow

# Configure calls AM_INIT_AUTOMAKE, but Automake fails as there is no Makefile.am.
# Tell dh-autoreconf to skip automake.
export AUTOMAKE = true

# Expose maintainer address to build/mkversion (see debian/patches/set-maintainer-name)
export DEB_MAINTAINER := $(shell sed -ne 's/Maintainer:\s\+//p' debian/control)

# Expose DEB_VERSION to build/version.sh (see debian/patches/debian-version)
export DEB_VERSION

# Workaround for bad glibc behavior when resolving localhost
export RESOLV_MULTI = off

CONFIG		= $(shell grep -v "^\#" debian/configure.options)
ifeq ($(DEB_HOST_ARCH_OS),hurd)
	CONFIG += --disable-bdb --disable-hdb --disable-mdb
endif
ifneq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
	CONFIG += --disable-slapd
endif

CONTRIB_MODULES = autogroup lastbind passwd passwd/argon2 passwd/pbkdf2 passwd/sha2 smbk5pwd

# Ensure CC is set correctly for cross builds, unless it has already
# been set explicitly.
ifeq ($(origin CC),default)
	export CC := $(DEB_HOST_GNU_TYPE)-gcc
endif

installdir	:= $(CURDIR)/debian/tmp
builddir	:= $(CURDIR)/debian/build
slapddir	:= $(CURDIR)/debian/slapd/usr/sbin

MAKEVARS	:= STRIP=

# Standard variables used in contrib Makefiles.
# We override these in make invocations rather than patch every one.
CONTRIB_MAKEVARS := \
	LDAP_BUILD='$(builddir)' \
	prefix=/usr \
	ldap_subdir=/ldap \
	moduledir='$$(libdir)$$(ldap_subdir)'

# These variables are used only by get-orig-source, which will normally only
# be run by maintainers.
VERSION = $(subst +dfsg,,$(DEB_VERSION_UPSTREAM))
URL     = https://www.openldap.org/software/download/OpenLDAP/openldap-release/

# Download the upstream source and make changes as required for DFSG reasons.
# Assumes wget is available, as this is generally only used by the package
# maintainers.
get-orig-source:
	@if [ ! -d "debian/schema" ] ; then \
	    echo 'Run this from the top directory of the Debian source' >&2; \
	    exit 1; \
	fi
	wget $(URL)/openldap-$(VERSION).tgz
	tar xzf openldap-$(VERSION).tgz
	rm -r openldap-$(VERSION)/doc/drafts
	rm -r openldap-$(VERSION)/doc/rfc
	set -e; for schema in debian/schema/*.schema debian/schema/*.ldif ; do \
	    file=`basename "$$schema"`; \
	    rm openldap-$(VERSION)/servers/slapd/schema/$$file; \
	done
	mv openldap-$(VERSION) openldap-$(VERSION)+dfsg
	tar cf openldap_$(VERSION)+dfsg.orig.tar openldap-$(VERSION)+dfsg
	rm -r openldap-$(VERSION)+dfsg
	gzip -9 openldap_$(VERSION)+dfsg.orig.tar

DH = dh $@ --builddirectory=$(builddir)
.PHONY: build
build:
	$(DH)
%:
	$(DH)

# Only contrib/ldapc++ uses Automake, so special care is needed to update
# config.guess and config.sub at the top level.
autoreconf:
	autoreconf -f -i . contrib/ldapc++
	cp -f /usr/share/misc/config.guess /usr/share/misc/config.sub build/

override_dh_autoreconf:
	dh_autoreconf debian/rules -- autoreconf

override_dh_auto_configure:
	# Check if we include the RFCs, Internet-Drafts, or upstream schemas
	# with RFC text (which are non DFSG-free).  You can set DFSG_NONFREE
	# to build the packages from the unchanged upstream sources but Debian
	# can not ship the RFCs in main so this test is here to make sure it
	# does not get in by accident again. -- Torsten
	if [ -z "$(DFSG_NONFREE)" ]; then \
	    if [ -e doc/drafts ] || [ -e doc/rfc ]; then exit 1; fi; \
	    if [ -e servers/slapd/schema/core.schema ] \
	       && grep -q 'RFC 4519 definition' servers/slapd/schema/core.schema; \
	    then \
		exit 1; \
	    fi; \
	fi

	# Copy our stripped schema versions into where upstream expects them.
	if [ -z "$(DFSG_NONFREE)" ]; then \
		cp debian/schema/*.schema debian/schema/*.ldif \
			servers/slapd/schema/; \
	fi

	dh_auto_configure -- $(CONFIG)

override_dh_auto_build:
	dh_auto_build -- $(MAKEVARS)
ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
	for mod in $(CONTRIB_MODULES); do \
		dh_auto_build -Dcontrib/slapd-modules/$$mod -Bcontrib/slapd-modules/$$mod -- $(CONTRIB_MAKEVARS) || exit $$?; \
	done
endif

override_dh_auto_test:
ifeq ($(DEB_HOST_ARCH),ppc64el)
	# Disable test060-mt-host on ppc64el until #866122 is fixed.
	rm -f tests/scripts/test060-mt-hot
endif
	dh_auto_test

override_dh_auto_install:
	dh_auto_install -- $(MAKEVARS)
ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
	for mod in $(CONTRIB_MODULES); do \
		dh_auto_install -Dcontrib/slapd-modules/$$mod -Bcontrib/slapd-modules/$$mod -- $(CONTRIB_MAKEVARS) || exit $$?; \
	done

	# Empty the dependency_libs file in the .la files.
	for F in $(installdir)/usr/lib/ldap/*.la; do \
		sed -i "s/^dependency_libs=.*/dependency_libs=''/" $$F; \
	done
endif
	
	# Check all built libraries for unresolved symbols except for the
	# libslapi library.  It is a special case since the SLAPI interface
	# depends on symbols defined in slapd itself.  Those symbols will
	# remain unresolved until the plugin is loaded into slapd.
	for F in $(installdir)/usr/lib/$(DEB_HOST_MULTIARCH)/*.so.*.*.*; do \
	    if echo "$$F" | grep -q libslapi ; then \
	        continue; \
	    fi; \
	    if LD_LIBRARY_PATH=$(installdir)/usr/lib/$(DEB_HOST_MULTIARCH) ldd -d -r $$F 2>&1 | grep '^undefined symbol:'; then \
	        echo; \
	        echo "library $$F has undefined references.  Please fix this before continuing."; \
		exit 1; \
	    fi; \
	done

	# Upstream manpages are section 8C but installed as section 8
	find $(installdir)/usr/share/man -name \*.8 \
		| xargs perl -pi -e 's#(\.TH \w+ 8)C#$$1#'

override_dh_installinit:
	dh_installinit -- "defaults 19 80"

ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
override_dh_installman:
	dh_installman
	rm -f $(CURDIR)/debian/slapd/usr/share/man/man5/slapo-smbk5pwd.*

override_dh_fixperms-arch:
	dh_fixperms
	chmod +x $(CURDIR)/debian/slapd/usr/share/slapd/ldiftopasswd
endif

override_dh_strip:
	dh_strip -plibldap-2.4-2 --dbgsym-migration='libldap-2.4-2-dbg (<< 2.4.45+dfsg-1~)'
	dh_strip -pslapd --dbgsym-migration='slapd-dbg (<< 2.4.45+dfsg-1~)'
	dh_strip --remaining-packages
ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
	# hardlink these so not confined by apparmor; do this here and not
	# in dh_link so that dh_strip doesn't get confused and put the wrong
	# binary in the debug package.
	for f in slapacl slapadd slapauth slapcat slapdn slapindex slappasswd slaptest slapschema ; do \
	    ln -f $(slapddir)/slapd $(slapddir)/$$f ; \
	done
endif

override_dh_link:
	for pkg in libldap2-dev libldap-2.4-2; do \
		sed -e"s/\$${DEB_HOST_MULTIARCH}/$(DEB_HOST_MULTIARCH)/g" < debian/$$pkg.links.in > debian/$$pkg.links; \
	done
	dh_link

ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
override_dh_makeshlibs:
	echo "slapd:Provides=$$(objdump -p debian/slapd/usr/lib/$(DEB_HOST_MULTIARCH)/libslapi-*.so.* \
		| sed -ne '/SONAME/ { s/[[:space:]]*SONAME[[:space:]]*//; \
		                      s/\.so\./-/; p; q }' \
	)" >> debian/slapd.substvars
	dh_makeshlibs -pslapd -X/usr/lib/ldap/ -V "$$(sed -ne's/slapd:Provides=//p' debian/slapd.substvars)"
	dh_makeshlibs --remaining-packages
endif

ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
override_dh_installdeb:
	dh_installdeb
	perl -w debian/dh_installscripts-common -p slapd
endif

override_dh_auto_clean:
	dh_auto_clean
	# Update translation templates for debconf
	debconf-updatepo
ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
	# Remove our stripped schema from the upstream source area.
	if [ -z "$(DFSG_NONFREE)" ]; then \
	    set -e; for s in debian/schema/*.schema debian/schema/*.ldif; do \
	        rm -f servers/slapd/schema/`basename $$s`; \
	    done; \
	fi

	# Clean the contrib directory

## openldap 2.5.6+dfsg

=== debian/changelog ===
openldap (2.5.6+dfsg-1~exp1ubuntu1.1) impish-security; urgency=medium

  * SECURITY UPDATE: SQL injection in experimental back-sql backend
    - debian/patches/CVE-2022-29155.patch: escape filter values in
      servers/slapd/back-sql/search.c.
    - CVE-2022-29155

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 12 May 2022 09:09:13 -0400

openldap (2.5.6+dfsg-1~exp1ubuntu1) impish; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Enable AppArmor support:
      + d/apparmor-profile: add AppArmor profile
      + d/rules: use dh_apparmor
      + d/control: Build-Depends on dh-apparmor
      + d/slapd.README.Debian: add note about AppArmor
    - Enable ufw support:
      + d/control: suggest ufw.
      + d/rules: install ufw profile.
      + d/slapd.ufw.profile: add ufw profile.
    - d/{rules,slapd.py}: Add apport hook.
    - d/rules: better regexp to match the Maintainer tag in d/control,
      needed in the Ubuntu case because of XSBC-Original-Maintainer
      (Closes #960448, LP #1875697)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Tue, 17 Aug 2021 14:06:00 -0400

openldap (2.5.6+dfsg-1~exp1) experimental; urgency=medium

  [ Ryan Tandy ]
  * New upstream release.
  * Export the cn=config database to LDIF format before upgrading from 2.4.
  * slapd.README.Debian:
    - Remove text about the dropped evolution-ntlm patch.
    - Add guidance for recovering from upgrade failures.
  * Remove the debconf warning and README text about the unsafe ACL configured
    by default in versions before jessie.
  * Remove upgrade code for adding the pwdMaxRecordedFailure attribute to the
    ppolicy schema. It's obsolete since the schema has been internalized.

  [ Sergio Durigan Junior ]
  * Implement the "escape hatch" mechanism.
    - d/po/*.po: Update PO files given the new template note.
    - d/po/templates.pot: Update file.
    - d/slapd.templates: Add note warning user about a postinst failure,
      its possible cause and what to do.
    - d/slapd.postinst: Make certain upgrade functions return failure
      instead of exiting, which allows the postinst script to gracefully
      fail when applicable.  Also, when the general configuration upgrade
      fails, display a critical warning to the user.  Implement
      ignore_init_failure function.
    - d/slapd.prerm: Implement ignore_init_failure function.
    - d/slapd.scripts-common: Make certain functions return failure
      instead of exiting.
    - d/rules: Use dh_installinit's --error-handler to instruct it on how
      to handle possible errors with the init script.
    - d/slapd.NEWS: Add excerpt mentioning that the postinst script might
      error out if it can't migrate the existing (old) database backend.

 -- Ryan Tandy <ryan@nardis.ca>  Mon, 16 Aug 2021 18:32:29 -0700

openldap (2.5.5+dfsg-1~exp1ubuntu1) impish; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Enable AppArmor support:
      + d/apparmor-profile: add AppArmor profile
      + d/rules: use dh_apparmor
      + d/control: Build-Depends on dh-apparmor
      + d/slapd.README.Debian: add note about AppArmor
    - Enable ufw support:
      + d/control: suggest ufw.
      + d/rules: install ufw profile.
      + d/slapd.ufw.profile: add ufw profile.
    - d/{rules,slapd.py}: Add apport hook.
    - d/rules: better regexp to match the Maintainer tag in d/control,
      needed in the Ubuntu case because of XSBC-Original-Maintainer
      (Closes #960448, LP #1875697)
  * Dropped changes:
    - Enable GSSAPI support (first added in 2.4.18-0ubuntu2):
      + d/patches/gssapi.diff, thanks to Jerry Carter (Likewise):
        - Add --with-gssapi support
        - Make guess_service_principal() more robust when determining
          principal
      + d/configure.options: Configure with --with-gssapi
      + d/control: Added heimdal-dev as a build depend
      + d/rules:
        - Explicitly add -I/usr/include/heimdal to CFLAGS.
        - Explicitly add -I/usr/lib/<multiarch>/heimdal to LDFLAGS.
      + d/libldap-2.4-2.symbols: add symbols for GSSAPI support
      This should be dropped when the soname changes.
      [ Dropped as planned after soname bump due to 2.5.5 update. ]
    - Enable nss overlay:
      + d/rules:
        - add nssov to CONTRIB_MODULES
        - add sysconfdir to CONTRIB_MAKEVARS
      + d/slapd.install: install nssov overlay
      + d/slapd.manpages: install slapo-nssov(5) man page
      + d/p/contrib-makefiles: given the change in 2.4.47+dfsg-3 regarding
        Debian bug #919136, we also have to patch the nssov makefile
        accordingly and thus update this patch.
      [ Dropped as planned after soname bump due to 2.5.5 update. ]
    - Add support for CLDAP (UDP) support, back then required by
      likewise-open (first enabled in 2.4.17-1ubuntu2):
      + d/rules: Enable -DLDAP_CONNECTIONLESS
      + d/libldap-2.4-2.symbols: add symbols for CLDAP (UDP)
      This should be dropped when the soname changes.
      [ Dropped as planned after soname bump due to 2.5.5 update. ]
    - debian/patches/fix_test_timing.patch: fix FTBFS on riscv64 because
      of test timing issue.
      [ Dropped because the latest update improved the testcase and
        there is no FTBFS on riscv64 anymore. ]

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Tue, 15 Jun 2021 17:20:34 -0400

openldap (2.5.5+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
    - Drop patches applied upstream: ITS#9544, ITS#9548.
  * Mark slapd-contrib as breaking the old version of slapd to reduce the
    chance of upgrade failure due to slapd-contrib being unpacked first.

 -- Ryan Tandy <ryan@nardis.ca>  Fri, 11 Jun 2021 11:43:15 -0700

openldap (2.5.4+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
    - Changing olcAuthzRegexp dynamically is supported. (Closes: #761407)
    - Support for LANMAN password hashes has been removed. (Closes: #988033)


=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: openldap
 Section: net
 Priority: optional
-Maintainer: Debian OpenLDAP Maintainers <pkg-openldap-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OpenLDAP Maintainers <pkg-openldap-devel@lists.alioth.debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>,
  Torsten Landschoff <torsten@debian.org>,
  Ryan Tandy <ryan@nardis.ca>
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper-compat (= 12),
+               dh-apparmor,
                dpkg-dev (>= 1.17.14),
                groff-base,
                heimdal-multidev (>= 7.4.0.dfsg.1-1~) <!pkg.openldap.noslapd>,
                libargon2-dev <!pkg.openldap.noslapd>,
-               libdb5.3-dev <!pkg.openldap.noslapd>,
                libgnutls28-dev,
                libltdl-dev <!pkg.openldap.noslapd>,
                libperl-dev (>= 5.8.0) <!pkg.openldap.noslapd>,
@@ -18,10 +19,11 @@
                libwrap0-dev <!pkg.openldap.noslapd>,
                nettle-dev <!pkg.openldap.noslapd>,
                perl:any,
+               pkg-config (>= 0.29),
                po-debconf,
                unixodbc-dev <!pkg.openldap.noslapd>
 Build-Conflicts: libbind-dev, bind-dev, autoconf2.13
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://www.openldap.org/
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/openldap-team/openldap.git
@@ -31,11 +33,11 @@
 Architecture: any
 Build-Profiles: <!pkg.openldap.noslapd>
 Pre-Depends: debconf (>= 0.5) | debconf-2.0, ${misc:Pre-Depends}
-Depends: ${shlibs:Depends}, libldap-2.4-2 (= ${binary:Version}),
+Depends: ${shlibs:Depends}, libldap-2.5-0 (= ${binary:Version}),
  coreutils (>= 4.5.1-1), psmisc, perl:any (>> 5.8.0) | libmime-base64-perl,
  adduser, lsb-base (>= 3.2-13), ${perl:Depends}, ${misc:Depends}
 Recommends: ldap-utils
-Suggests: libsasl2-modules,
+Suggests: libsasl2-modules, ufw,
  libsasl2-modules-gssapi-mit | libsasl2-modules-gssapi-heimdal
 Conflicts: umich-ldapd, ldap-server, libltdl3 (= 1.5.4-1)
 Replaces: libldap2, ldap-utils (<< 2.2.23-3)
@@ -50,7 +52,7 @@
 Build-Profiles: <!pkg.openldap.noslapd>
 Depends: slapd (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Provides: slapd-smbk5pwd
-Breaks: slapd-smbk5pwd (<< 2.4.47+dfsg-2~)
+Breaks: slapd-smbk5pwd (<< 2.4.47+dfsg-2~), slapd (<< 2.5.4+dfsg-1~)
 Replaces: slapd-smbk5pwd (<< 2.4.47+dfsg-2~)
 Description: contributed plugins for OpenLDAP slapd
  This package contains a number of slapd overlays and plugins contributed by
@@ -69,7 +71,7 @@
 
 Package: ldap-utils
 Architecture: any
-Depends: ${shlibs:Depends}, libldap-2.4-2 (= ${binary:Version}), ${misc:Depends}
+Depends: ${shlibs:Depends}, libldap-2.5-0 (= ${binary:Version}), ${misc:Depends}
 Suggests: libsasl2-modules,
  libsasl2-modules-gssapi-mit | libsasl2-modules-gssapi-heimdal
 Conflicts: umich-ldap-utils, openldap-utils, ldap-client
@@ -81,7 +83,7 @@
  local or remote LDAP server and contain all the client programs
  required to access LDAP servers.
 
-Package: libldap-2.4-2
+Package: libldap-2.5-0
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -104,18 +106,26 @@
  These are common files for the run-time libraries for the OpenLDAP
  (Lightweight Directory Access Protocol) servers and clients.
 
-Package: libldap2-dev
+Package: libldap-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Conflicts: libldap-dev, libopenldap-dev
-Replaces: libopenldap-dev
-Provides: libldap-dev
-Depends: libldap-2.4-2 (= ${binary:Version}), ${misc:Depends}
+Provides: libldap2-dev
+Breaks: libldap2-dev (<< 2.5.4+dfsg-1~)
+Replaces: libldap2-dev (<< 2.5.4+dfsg-1~)
+Depends: libldap-2.5-0 (= ${binary:Version}), ${misc:Depends}
 Description: OpenLDAP development libraries
  This package allows development of LDAP applications using the OpenLDAP
  libraries. It includes headers, libraries and links to allow static and
  dynamic linking.
+
+Package: libldap2-dev
+Section: oldlibs
+Architecture: all
+Depends: libldap-dev, ${misc:Depends}
+Description: transitional package for libldap-dev
+ This is a transitional package from libldap2-dev to libldap-dev. It can be
+ safely removed.
 
 Package: slapi-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -7,15 +7,15 @@
 # want the checks for DFSG-freeness.
 #DFSG_NONFREE = 1
 
-export DEB_CFLAGS_MAINT_APPEND := -Wall -Wno-format-extra-args -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
-export DEB_BUILD_MAINT_OPTIONS := hardening=+pie,+bindnow
+export DEB_CFLAGS_MAINT_APPEND := -Wall -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
+export DEB_BUILD_MAINT_OPTIONS := hardening=+all
 
 # Configure calls AM_INIT_AUTOMAKE, but Automake fails as there is no Makefile.am.
 # Tell dh-autoreconf to skip automake.
 export AUTOMAKE = true
 
 # Expose maintainer address to build/mkversion (see debian/patches/set-maintainer-name)
-export DEB_MAINTAINER := $(shell sed -ne 's/Maintainer:\s\+//p' debian/control)
+export DEB_MAINTAINER := $(shell sed -ne 's/^Maintainer:\s\+//p' debian/control)
 
 # Expose DEB_VERSION to build/version.sh (see debian/patches/debian-version)
 export DEB_VERSION
@@ -25,13 +25,13 @@
 
 CONFIG		= $(shell grep -v "^\#" debian/configure.options)
 ifeq ($(DEB_HOST_ARCH_OS),hurd)
-	CONFIG += --disable-bdb --disable-hdb --disable-mdb
+	CONFIG += --disable-mdb
 endif
 ifneq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
 	CONFIG += --disable-slapd
 endif
 
-CONTRIB_MODULES = autogroup lastbind passwd passwd/argon2 passwd/pbkdf2 passwd/sha2 smbk5pwd
+CONTRIB_MODULES = autogroup lastbind passwd passwd/pbkdf2 passwd/sha2 smbk5pwd
 
 # Ensure CC is set correctly for cross builds, unless it has already
 # been set explicitly.
@@ -43,12 +43,11 @@
 builddir	:= $(CURDIR)/debian/build
 slapddir	:= $(CURDIR)/debian/slapd/usr/sbin
 
-MAKEVARS	:= STRIP=
-
 # Standard variables used in contrib Makefiles.
 # We override these in make invocations rather than patch every one.
 CONTRIB_MAKEVARS := \
 	LDAP_BUILD='$(builddir)' \
+	OPT= \
 	prefix=/usr \
 	ldap_subdir=/ldap \
 	moduledir='$$(libdir)$$(ldap_subdir)'
@@ -119,22 +118,15 @@
 	dh_auto_configure -- $(CONFIG)
 
 override_dh_auto_build:
-	dh_auto_build -- $(MAKEVARS)
+	dh_auto_build
 ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
 	for mod in $(CONTRIB_MODULES); do \
 		dh_auto_build -Dcontrib/slapd-modules/$$mod -Bcontrib/slapd-modules/$$mod -- $(CONTRIB_MAKEVARS) || exit $$?; \
 	done
 endif
 
-override_dh_auto_test:
-ifeq ($(DEB_HOST_ARCH),ppc64el)
-	# Disable test060-mt-host on ppc64el until #866122 is fixed.
-	rm -f tests/scripts/test060-mt-hot
-endif
-	dh_auto_test
-
 override_dh_auto_install:
-	dh_auto_install -- $(MAKEVARS)
+	dh_auto_install -- STRIP_OPTS=
 ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
 	for mod in $(CONTRIB_MODULES); do \
 		dh_auto_install -Dcontrib/slapd-modules/$$mod -Bcontrib/slapd-modules/$$mod -- $(CONTRIB_MAKEVARS) || exit $$?; \
@@ -165,36 +157,45 @@
 	find $(installdir)/usr/share/man -name \*.8 \
 		| xargs perl -pi -e 's#(\.TH \w+ 8)C#$$1#'
 
+ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
+override_dh_install-arch:
+	dh_install
+
+	# install AppArmor profile
+	install -D -m 644 $(CURDIR)/debian/apparmor-profile $(CURDIR)/debian/slapd/etc/apparmor.d/usr.sbin.slapd
+
+	# install Apport hook
+	install -D -m 644 $(CURDIR)/debian/slapd.py $(CURDIR)/debian/slapd/usr/share/apport/package-hooks/slapd.py
+
+	# install ufw profile
+	install -D -m 644 $(CURDIR)/debian/slapd.ufw.profile $(CURDIR)/debian/slapd/etc/ufw/applications.d/slapd
+
+	dh_apparmor -pslapd --profile-name=usr.sbin.slapd
+endif
+
 override_dh_installinit:
-	dh_installinit -- "defaults 19 80"
-
-ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
-override_dh_installman:
-	dh_installman
-	rm -f $(CURDIR)/debian/slapd/usr/share/man/man5/slapo-smbk5pwd.*
-
+	dh_installinit --no-restart-after-upgrade --error-handler=ignore_init_failure -- "defaults 19 80"
+
+ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
 override_dh_fixperms-arch:
 	dh_fixperms
 	chmod +x $(CURDIR)/debian/slapd/usr/share/slapd/ldiftopasswd
 endif
 
 override_dh_strip:
-	dh_strip -plibldap-2.4-2 --dbgsym-migration='libldap-2.4-2-dbg (<< 2.4.45+dfsg-1~)'
 	dh_strip -pslapd --dbgsym-migration='slapd-dbg (<< 2.4.45+dfsg-1~)'
 	dh_strip --remaining-packages
 ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
 	# hardlink these so not confined by apparmor; do this here and not
 	# in dh_link so that dh_strip doesn't get confused and put the wrong
 	# binary in the debug package.
-	for f in slapacl slapadd slapauth slapcat slapdn slapindex slappasswd slaptest slapschema ; do \
+	for f in slapacl slapadd slapauth slapcat slapdn slapindex slapmodify slappasswd slapschema slaptest; do \
 	    ln -f $(slapddir)/slapd $(slapddir)/$$f ; \
 	done
 endif
 
 override_dh_link:
-	for pkg in libldap2-dev libldap-2.4-2; do \
-		sed -e"s/\$${DEB_HOST_MULTIARCH}/$(DEB_HOST_MULTIARCH)/g" < debian/$$pkg.links.in > debian/$$pkg.links; \
-	done
+	sed -e"s/\$${DEB_HOST_MULTIARCH}/$(DEB_HOST_MULTIARCH)/g" < debian/libldap-dev.links.in > debian/libldap-dev.links
 	dh_link
 
 ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
@@ -213,6 +214,9 @@
 	perl -w debian/dh_installscripts-common -p slapd
 endif
 
+override_dh_missing:
+	dh_missing --fail-missing
+
 override_dh_auto_clean:
 	dh_auto_clean
 	# Update translation templates for debconf
@@ -220,9 +224,3 @@
 ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
 	# Remove our stripped schema from the upstream source area.
 	if [ -z "$(DFSG_NONFREE)" ]; then \
-	    set -e; for s in debian/schema/*.schema debian/schema/*.ldif; do \
-	        rm -f servers/slapd/schema/`basename $$s`; \
-	    done; \
-	fi
-
-	# Clean the contrib directory

## openldap 2.5.7+dfsg

=== debian/changelog ===
openldap (2.5.7+dfsg-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Don't run autoreconf in contrib/ldapc++. We don't build it, and it is not
    yet compatible with autoconf 2.71. (Closes: #993032)
  * Stop disabling automake in debian/rules now that upstream removed the
    AM_INIT_AUTOMAKE invocation.
  * Drop custom config.{guess,sub} handling. dh_update_autotools_config does
    the right thing for us.
  * Update Standards-Version to 4.6.0; no changes required.
  * debian/not-installed: Add the ldapvc.1 man page.

 -- Ryan Tandy <ryan@nardis.ca>  Mon, 30 Aug 2021 18:54:25 -0700

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,11 @@
 Source: openldap
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OpenLDAP Maintainers <pkg-openldap-devel@lists.alioth.debian.org>
+Maintainer: Debian OpenLDAP Maintainers <pkg-openldap-devel@lists.alioth.debian.org>
 Uploaders: Steve Langasek <vorlon@debian.org>,
  Torsten Landschoff <torsten@debian.org>,
  Ryan Tandy <ryan@nardis.ca>
 Build-Depends: debhelper-compat (= 12),
-               dh-apparmor,
                dpkg-dev (>= 1.17.14),
                groff-base,
                heimdal-multidev (>= 7.4.0.dfsg.1-1~) <!pkg.openldap.noslapd>,
@@ -23,7 +21,7 @@
                po-debconf,
                unixodbc-dev <!pkg.openldap.noslapd>
 Build-Conflicts: libbind-dev, bind-dev, autoconf2.13
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://www.openldap.org/
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/openldap-team/openldap.git
@@ -37,7 +35,7 @@
  coreutils (>= 4.5.1-1), psmisc, perl:any (>> 5.8.0) | libmime-base64-perl,
  adduser, lsb-base (>= 3.2-13), ${perl:Depends}, ${misc:Depends}
 Recommends: ldap-utils
-Suggests: libsasl2-modules, ufw,
+Suggests: libsasl2-modules,
  libsasl2-modules-gssapi-mit | libsasl2-modules-gssapi-heimdal
 Conflicts: umich-ldapd, ldap-server, libltdl3 (= 1.5.4-1)
 Replaces: libldap2, ldap-utils (<< 2.2.23-3)

=== debian/rules ===
--- 
+++ 
@@ -10,12 +10,8 @@
 export DEB_CFLAGS_MAINT_APPEND := -Wall -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
 export DEB_BUILD_MAINT_OPTIONS := hardening=+all
 
-# Configure calls AM_INIT_AUTOMAKE, but Automake fails as there is no Makefile.am.
-# Tell dh-autoreconf to skip automake.
-export AUTOMAKE = true
-
 # Expose maintainer address to build/mkversion (see debian/patches/set-maintainer-name)
-export DEB_MAINTAINER := $(shell sed -ne 's/^Maintainer:\s\+//p' debian/control)
+export DEB_MAINTAINER := $(shell sed -ne 's/Maintainer:\s\+//p' debian/control)
 
 # Expose DEB_VERSION to build/version.sh (see debian/patches/debian-version)
 export DEB_VERSION
@@ -84,15 +80,6 @@
 	$(DH)
 %:
 	$(DH)
-
-# Only contrib/ldapc++ uses Automake, so special care is needed to update
-# config.guess and config.sub at the top level.
-autoreconf:
-	autoreconf -f -i . contrib/ldapc++
-	cp -f /usr/share/misc/config.guess /usr/share/misc/config.sub build/
-
-override_dh_autoreconf:
-	dh_autoreconf debian/rules -- autoreconf
 
 override_dh_auto_configure:
 	# Check if we include the RFCs, Internet-Drafts, or upstream schemas
@@ -157,22 +144,6 @@
 	find $(installdir)/usr/share/man -name \*.8 \
 		| xargs perl -pi -e 's#(\.TH \w+ 8)C#$$1#'
 
-ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
-override_dh_install-arch:
-	dh_install
-
-	# install AppArmor profile
-	install -D -m 644 $(CURDIR)/debian/apparmor-profile $(CURDIR)/debian/slapd/etc/apparmor.d/usr.sbin.slapd
-
-	# install Apport hook
-	install -D -m 644 $(CURDIR)/debian/slapd.py $(CURDIR)/debian/slapd/usr/share/apport/package-hooks/slapd.py
-
-	# install ufw profile
-	install -D -m 644 $(CURDIR)/debian/slapd.ufw.profile $(CURDIR)/debian/slapd/etc/ufw/applications.d/slapd
-
-	dh_apparmor -pslapd --profile-name=usr.sbin.slapd
-endif
-
 override_dh_installinit:
 	dh_installinit --no-restart-after-upgrade --error-handler=ignore_init_failure -- "defaults 19 80"
 
@@ -224,3 +195,13 @@
 ifeq ($(filter pkg.openldap.noslapd,$(DEB_BUILD_PROFILES)),)
 	# Remove our stripped schema from the upstream source area.
 	if [ -z "$(DFSG_NONFREE)" ]; then \
+	    set -e; for s in debian/schema/*.schema debian/schema/*.ldif; do \
+	        rm -f servers/slapd/schema/`basename $$s`; \
+	    done; \
+	fi
+
+	# Clean the contrib directory
+	for mod in $(CONTRIB_MODULES); do \
+		dh_auto_clean -Dcontrib/slapd-modules/$$mod -Bcontrib/slapd-modules/$$mod || exit $?; \
+	done
+endif
